<script setup lang="ts">
  const props = defineProps<{
    controller?: ReturnType<typeof useModal>;
  }>();

  const { setJoinedWithAudioOnly } = useVideoSetup();
  const { setup: setupVideoCall } = useVideoCall();

  const onReload = () => {
    location.reload();
  };

  const joinWithAudio = () => {
    setJoinedWithAudioOnly(true);
    setupVideoCall();
    props.controller?.close();
  };
</script>

<template>
  <SwModal backdrop-display="static" :controller="controller">
    <template #header>
      <div
        class="border-b-1 bg-background-raised border-border md:(hidden rounded-t-md) flex items-center justify-between rounded-t-none border-0 px-6 py-4"
      >
        <h3 class="font-bold capitalize">
          {{ $t('setting.videoAudio') }}
        </h3>
        <button
          type="button"
          class="text-information hover:bg-interactive-hover active:bg-interactive-pressed rounded-md bg-transparent p-2 outline-none"
          @click="controller?.close"
        >
          <span class="i-sw-regular:times-xs" />
        </button>
      </div>
    </template>
    <template #body>
      <div
        class="md:justify-initial md:(h-fit items-start) flex h-full w-full flex-col items-center justify-center space-y-8 p-4 sm:max-w-md"
      >
        <SwEmptyState
          :title="$t('presentation.joinNoDevices.noDevices')"
          :sublime="$t('presentation.joinNoDevices.noDevicesDescription')"
          class="md:max-w-[408px]"
        >
          <template #icon>
            <span class="i-sw-solid:video-slash m-auto p-0" />
          </template>
          <template #actions>
            <div class="flex flex-col space-y-2">
              <SwButton class="mx-auto font-medium" @click="onReload">
                {{ $t('presentation.joinNoDevices.tryAgain') }}
              </SwButton>
              <div>
                <SwLink class="text-sm/6" @click="joinWithAudio">{{
                  $t('presentation.joinNoDevices.joinWithAudio')
                }}</SwLink>
              </div>
            </div>
          </template>
        </SwEmptyState>
        <AllowDeviceSteps />
      </div>
    </template>
  </SwModal>
</template>

<style scoped>
  .allow-device-steps {
    @apply md:max-w-[408px];
  }
</style>
